=begin
Ce programme opre sur des chaines de caractres et explore diffrentes fonctions
=end


### Cadrage
#A gauche sur 20 = Abcdefgh             X
#Centre   sur 20 =       Abcdefgh       X
#A droite sur 20 =             Abcdefgh X

s1="Abcdefgh"
puts "--> CADRAGE"
puts "A gauche sur 20 = #{s1.ljust(20)} X"
puts "Centre   sur 20 = #{s1.center(20)} X"
puts "A droite sur 20 = #{s1.rjust(20)} X"
puts 



### Extraction de sous-chaines
#2eme car        = b
#3eme car, sur 4 = cdef
#3eme au 6eme car= cdef
#2 a gauche      = Ab
#2 a droite      = gh
#3

puts "--> SOUS-CHAINES"
puts "2eme car         = #{s1[1]}"
puts "3eme car, sur 4  = #{s1[2, 4]}"
puts "3eme au 6eme car = #{s1[2..5]}"
puts "2 a gauche       = #{s1[0, 2]}"
puts "2 a droite       = #{s1[-2, 2]}"
puts "position de 'de' = #{s1.index("de")}"
puts



### Majuscules/minuscules
#Abcdefgh ABCDEFGH abcdefgh aBCDEFGH

puts "--> MAJUSCULES/MINUSCULES"
print s1, " ", s1.upcase, " ", s1.downcase, " ", s1.swapcase
puts 
puts



### Formatage 
#1 02 03 Nous       irons au bois

puts "--> FORMATAGE"
w1="%2d %02d %002d %-10s irons %s bois" % [1, 2, 3, "Nous", "au"]
puts w1 
puts



### Remplacement de caractres et chaines
#Abcdefgh -> aBcDeXgh
#Abcdefgh
#Ab12345fghX
#AbcWXCVdefgh

puts "--> REMPLACEMENT DE CARACTERES"
puts "#{s1} -> #{s1.tr("bdAf", "BDaX")}"
w1=s1+"X"         # w1 est diffrent de s1
w1["cde"]="12345" #remplac par une chaine plus longue
puts s1
puts w1
w1=s1+" "
puts "#{w1.insert(3, "WXCV")}"
# attention si w1=s1, puts s1 donne la valeur de w1 modifi !!!!
puts



### Concatnation, repetition
#Aa./
#AbcdefghAbcdefgh

puts "--> CONCATENATION ET REPETITION"
puts "3 manieres enchainees : +, concat, <<"
puts "#{(("A"+"a").concat("."))<<"/"}"
puts "Repetition #{s1 * 2}"
puts


### Balayage de chaines
#a..
#b..
#c..
#fin ligne
#d..
#e..
#f..
#fin ligne

puts "--> BALAYAGE DE CHAINES"
s2="abc\ndef" #n marque une nouvelle ligne
s2.each_line {|lig|
    lig.chomp.each_char {|car|
        puts "#{car}.."
	}
    puts "fin ligne"
    }
puts
